// Source file for point set class



// Include files

#include "stdio.h"
#include "stdlib.h"
#include "assert.h"
#include "pointset.h"



PointSet::
PointSet(int maxpoints)
  : points(0),
    maxpoints(maxpoints),
    npoints(0)
{
  // Allocate points
  if (maxpoints > 0) {
    points = new Point [ maxpoints ];
    assert(points);
  }
}


PointSet::
~PointSet(void)
{
  // Deallocate points
  if (points) delete [] points;
}



void PointSet::
Insert(const Point& point)
{
  // Grow as needed
  if (npoints == maxpoints) {
    maxpoints = (maxpoints > 0) ? 2 * maxpoints : 4;
    Point *newpoints = new Point [ maxpoints ];
    for (int i = 0; i < npoints; i++) newpoints[i] = points[i];
    delete [] points;
    points = newpoints;
  }

  // Insert point
  points[npoints++] = point;
}



