// Header file for point set class



struct Point {
  double px, py, pz;
  double nx, ny, nz;
};
  



class PointSet {
public:
  // Constructors
  PointSet(int maxpoints = 0);
  ~PointSet(void);

  // Property functions
  int NPoints(void) const;

  // Access functions
  Point& operator[](int i);

  // Manipulation functions
  void Insert(const Point& point);

  // Draw functions
  void Draw(void) const;

private:
  Point *points;
  int maxpoints;
  int npoints;
};



// Inline functions

inline int PointSet::
NPoints(void) const
{
  return npoints;
}



inline Point& PointSet::
operator[](int i)
{
  return points[i];
}














